unit DebugUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TDebugForm = class(TForm)
    CloseButton: TButton;
    SaveButton: TButton;
    DebugMemo: TMemo;
    SaveDialog: TSaveDialog;
    procedure CloseButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DebugForm: TDebugForm;
  
procedure Debug(const Msg: String);

implementation

{$R *.DFM}

procedure TDebugForm.CloseButtonClick(Sender: TObject);
begin
  Close;
end;

procedure Debug(const Msg: String);
begin
  WITH DebugForm DO
  BEGIN
    IF NOT Visible THEN Show;
    DebugMemo.Lines.Add(TimeToStr(Now)+': '+Msg);
  END;
end;

procedure TDebugForm.FormShow(Sender: TObject);
begin
  DebugMemo.Lines.Add(DateTimeToStr(Now)+': Debugging Started');
end;

procedure TDebugForm.SaveButtonClick(Sender: TObject);
begin
  IF SaveDialog.Execute THEN
    DebugMemo.Lines.SaveToFile(SaveDialog.FileName);
end;

end.
