unit Main;
{

new in v 2.0:
- MDI (Somewhere in 2000/2001)
- Printing (5.1.2002)

}
interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList, Psock, NMHttp,shdocvw;

const IPCMessage = 1111;
type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileCloseItem: TMenuItem;
    WindowMenu: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    WindowMinimizeItem: TMenuItem;
    ActionList1: TActionList;
    FileNew1: TAction;
    FileExit1: TAction;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowArrangeAll1: TWindowArrange;
    WindowMinimizeAll1: TWindowMinimizeAll;
    HelpAbout1: TAction;
    FileClose1: TWindowClose;
    WindowTileVertical1: TWindowTileVertical;
    WindowTileItem2: TMenuItem;
    ImageList: TImageList;
    GoToMenu: TMenuItem;
    N2: TMenuItem;
    CloseTimer: TTimer;
    TileTimer: TTimer;
    FilePrintItem: TMenuItem;
    FilePrint1: TAction;
    procedure FileNew1Execute(Sender: TObject);
    procedure HelpAbout1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GoToMenuClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure CloseTimerTimer(Sender: TObject);
    procedure TileTimerTimer(Sender: TObject);
    procedure FilePrint1Execute(Sender: TObject);
  private
    { Private declarations }
    Bookmarks:TStringList;
  protected
    procedure IPC(VAR Msg:TMessage); message IPCMessage;
  public
    Filter:Record
                 Proto: Record
                   Inc,Exc: TStringList;
                 END;
                 Host: Record
                   Inc,Exc: TStringList;
                 END;
                 Path: Record
                   Inc,Exc: TStringList;
                 END
           END;
    CustomButton:Record
      URL,Hint,Caption:String;
    END;
    AutoURL,IncFilter,ExcFilter:TstringList;
    AutoDebug,NOURL,NOEXIT,FORCEMAX:Boolean;
    Icons:Array [0..1] of TBitMap;
    procedure CreateMDIChild(const URL: string);
    { Public declarations }
  end;

var
  MainForm: TMainForm;

const
  VersionString:string = 'ResBrow 2';
  Version:string = '2.0';

CONST
  BackupConfig = '/NOCLOSE'+#$A+
                 '/I'+#$A+
                 'about:'+#$A+
                 '/FET'+#$A+
                 'Could not read Configuration. Please call the Administrator !'+#$A+
                 '/STAYTOP'+#$A+
                 '/NOURL'+#$A+
                 '/FORCEMAX'+#$A+
                 'about: Could not read Configuration. Please call the Administrator !';

  ResBrowHTTPToken='RESBROW';
  CRLF=#$D#$A;
VAR
  FilterErrorText:String = 'Access to the requested site has been restricted !';
  HomeURL:String = 'about:blank';
  AboutString:WideString;
  OpenNewWindowParams:WideString;

implementation

{$R *.DFM}
{$R data.res}

uses ChildWin, About, DebugUnit;

VAR FirstTime:Boolean;



procedure TMainForm.FormCreate(Sender: TObject);

  procedure AddBookMark(Text,URL:WideString);
  VAR MyMenu:TMenuItem;
  begin
    MyMenu:=TMenuItem.Create(MainForm);
    WITH MyMenu DO
    BEGIN
      IF Pos('|',Text)>0 THEN
      // set up hint, too
      BEGIN
        Hint:=Copy(Text,Pos('|',Text)+1,Length(Text)-Pos('|',Text));
        Caption:=Copy(Text,1,Pos('|',Text)-1);
      END
      ELSE Caption:=Text;
// setup the custom button if this is the first bookmark
      IF Bookmarks.Count=0 THEN
      BEGIN
        CustomButton.URL:=URL;
        CustomButton.Hint:=Hint;
        CustomButton.Caption:=Caption;
      END;
      Tag:=Bookmarks.Add(URL);
//      Name:='BookMark'+IntToStr(Tag);
      OnClick:=MainForm.GoToMenuClick;
    END;
    GoToMenu.Add(MyMenu);
  end;

VAR dummyb,dummyb1:Word;
    dummys:WideString;
    dummyi:Integer;
    config:TStringList;
    HTTP:TNMHTTP;
    TempPath:Array [0..255] of Char;

begin
// Create Objects
// Icons for the Stop/Refresh button
  Icons[0]:=TBitMap.Create;
  Icons[1]:=TBitMap.Create;
  Icons[0].Handle:=LoadBitmap(HINSTANCE,'stop');
  Icons[1].Handle:=LoadBitmap(HINSTANCE,'refresh');
// List of BookMarks
  BookMarks:=TStringList.Create;
// List of automatically opened URLs (passed by command line)
  AutoURL:=TStringList.Create;
(*
// Initialize the Filter
  With Filter DO
  BEGIN
    Proto.Inc:=TStringList.Create;
    Proto.Exc:=TStringList.Create;
    Host.Inc:=TStringList.Create;
    Host.Exc:=TStringList.Create;
    Path.Inc:=TStringList.Create;
    Path.Exc:=TStringList.Create;
  END;
*)
// Initialize Variables
  NOURL:=FALSE;
  NOEXIT:=FALSE;
  FORCEMAX:=FALSE;
  AutoDebug:=FALSE;
// Set general params
  TileMode:=tbHorizontal;
// Parse Command Line Parameters

// IF any parameters given
  IF ParamCount>0 THEN
  BEGIN
    Config:=TStringList.Create;
    FOR dummyb:=1 TO ParamCount DO //collect params for next instance of ResBrow (for the /noclose option)
      OpenNewWindowParams := OpenNewWindowParams +' "'+ParamStr(dummyb)+'"';
    IF (ParamStr(1)='/@') AND ((ParamCount=2) OR (ParamCount=3)) THEN
    BEGIN
      // Read params from file or command line
      IF Pos('HTTP:',UpperCase(ParamStr(2)))>0 THEN
      BEGIN
      // Read from URL
         HTTP:=TNMHTTP.Create(Application);
         HTTP.TimeOut:=10000;
         try
           try
             HTTP.Get(ParamStr(2));
             IF Pos(ResBrowHTTPToken,UpperCase(HTTP.Body))=0 THEN
             // not a valid ResBrow configuration, if save param given try previous config
             // otherwise go to safe mode and try again later
             BEGIN
               IF (ParamCount=3) AND (Pos('/SAVE',UpperCase(ParamStr(3)))>0) THEN
               BEGIN
                 try
                   IF GetTempPath(256,@TempPath)>0 THEN
                   // got temp dir
                   BEGIN
                     Config.LoadFromFile(String(temppath)+'RESBROW.CFG');
                     // got some file, check wether it's our config file
                     IF Pos(ResBrowHTTPToken,UpperCase(Config.Text))=0 THEN
                     // didn't find token, must be empty of fake. go back to safe mode and try again later
                     BEGIN
                       Config.Text:=BackupConfig;
                       CloseTimer.Enabled:=TRUE;
                     END
                     // if all is OK delete token
                     ELSE Config.Delete(Config.IndexOf(ResBrowHTTPToken));
                   END;
                 except
                 // if any problem happened during recovery from the previously saved config, go to save mode and try again
                   Config.Text:=BackupConfig;
                   CloseTimer.Enabled:=TRUE;
                 end;
               END // IF /SAVE is given
               ELSE
               // this happens if the downlaod fails and no /SAVE option was given
               BEGIN
                 Config.Text:=BackupConfig;
                 CloseTimer.Enabled:=TRUE;
               END;
             END
             ELSE
             // means we downloaded a valid config from the internet.
             BEGIN
               Config.Text:=HTTP.Body;
               IF (ParamCount=3) AND (Pos('/SAVE',UpperCase(ParamStr(3)))>0) THEN
               BEGIN
               // this means we have to save the good config to the local file
                 try
                   IF GetTempPath(256,@TempPath)>0 THEN
                   // got temp dir
                   BEGIN
                     Config.SaveToFile(String(TempPath)+'RESBROW.CFG');
                   END;
                 except
                 end;
               END; // IF /SAVE was given
               // remove the token
               Config.Delete(Config.IndexOf(ResBrowHTTPToken));
             END; // we found a valid config
           except
           // if anything happens during the whole internet-related stuff, try to read old config (if /SAVE) or go safe mode
             IF (ParamCount=3) AND (Pos('/SAVE',UpperCase(ParamStr(3)))>0) THEN
             BEGIN
               try
                 IF GetTempPath(256,@TempPath)>0 THEN
                 // got temp dir
                 BEGIN
                   Config.LoadFromFile(String(temppath)+'RESBROW.CFG');
                   // got some file, check wether it's our config file
                   IF Pos(ResBrowHTTPToken,UpperCase(Config.Text))=0 THEN
                   // didn't find token, must be empty of fake. go back to safe mode and try again later
                   BEGIN
                     Config.Text:=BackupConfig;
                     CloseTimer.Enabled:=TRUE;
                   END
                   // if all is OK delete token
                   ELSE Config.Delete(Config.IndexOf(ResBrowHTTPToken));
                 END;
               except
               // if any problem happened during recovery from the previously saved config, go to save mode and try again
                 Config.Text:=BackupConfig;
                 CloseTimer.Enabled:=TRUE;
               end;
             END // IF /SAVE is given
             ELSE
             // this happens if the downlaod fails and no /SAVE option was given
             BEGIN
               Config.Text:=BackupConfig;
               CloseTimer.Enabled:=TRUE;
             END;
           END;
         finally
           HTTP.Free;
         end;
      END
      ELSE
        try
          Config.LoadFromFile(ParamStr(2))
        except
        // if we couldn't read from the file, go safe mode.
           Config.Text:=BackupConfig;
           CloseTimer.Enabled:=TRUE;
        END;
    END // /@ found. Now begins the "classical" command line parameters evaluation
    ELSE FOR dummyb:=1 TO ParamCount DO Config.Add(ParamStr(dummyb));
    dummyb:=0;
    // eat params one by one
    WHILE dummyb<Config.Count DO
    BEGIN
      IF Pos('/HOME',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
        // if no parameter supplied ignore silently.
        IF Config.Count-1>dummyb THEN
        BEGIN
          Inc(dummyb);
          HomeURL:=Config.Strings[dummyb];
        END;
      END
(*      ELSE IF Pos('/CLOSEON',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
        // if no parameter supplied ignore silently.
        IF Config.Count-1>dummyb THEN
        BEGIN
          Inc(dummyb);
          CloseOnURL:=UpperCase(Config.Strings[dummyb]);
        END;
      END
*)      ELSE IF Pos('/NOURL',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
          NOURL:=TRUE;
      END
      ELSE IF Pos('/D',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
         AutoDebug:=TRUE;
      END
      ELSE IF Pos('/P',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
        FOR dummyb:=0 to Menu.Items.Count-1 DO
          IF Menu.Items[dummyb].Name = 'File1' THEN
          WITH Menu.Items[dummyb] DO
          BEGIN
            FOR dummyb1:=0 to Count-1 DO
              IF Items[dummyb1].Name = 'FilePrintItem' THEN
              WITH Items[dummyb1] DO
              BEGIN
                Enabled:=TRUE;
                Visible:=TRUE;
              END;
          END;
      END
      ELSE IF Pos('/NOCLOSE',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
        MainForm.BorderIcons:= [] ;
        MainForm.Update;
        NoExit:=TRUE;
        SystemParametersInfo (97, Word (True), @Dummyi, 0); {no alt-tab or ctrl-alt-del any more on Win9x}
      END
      ELSE IF Pos('/MAX',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
        MainForm.WindowState := wsMaximized
      END
      ELSE IF Pos('/FORCEMAX',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
        MainForm.Width:=Screen.Width;
        MainForm.Height:=Screen.Height;
        MainForm.BorderStyle:=bsNone;
        MainForm.BorderIcons:= [] ;
        MainForm.Update;
        FORCEMAX:=TRUE;
//        Application.MessageBox(pchar('screen.width='+IntToStr(screen.width)+'exitbutton.left='+inttostr(exitbutton.left)+' urledit.right='+inttostr(urledit.width+urledit.left)),pchar('info'),MB_OK);
        // I assume that ResBrowser runs as a kiosk application. otherwise it doesn't make sense
      END
      ELSE IF Pos('/STAYTOP',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
//        Main.FormStyle:=fsStayOnTop;
          SetWindowPos(MainForm.Handle,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE + SWP_NOMOVE);
      END
      ELSE IF Pos('/FET',UpperCase(Config.Strings[dummyb]))>0 THEN
      // Filter Error Text
      BEGIN
        IF Config.Count-1>dummyb THEN
        // if value is missing ignore
        BEGIN
          Inc(dummyb);
          FilterErrorText:=Config.Strings[dummyb];
        END;
      END
      ELSE IF Pos('/I',UpperCase(Config.Strings[dummyb]))>0 THEN
      // include filters
      BEGIN
        IF Config.Count-1>dummyb THEN
        // if value is missing ignore
        BEGIN
          Inc(dummyb);
          IF IncFilter=nil THEN IncFilter:=TStringList.Create;
          IncFilter.Add(UpperCase(Config.Strings[dummyb]));
        END
      END
      ELSE IF Pos('/X',UpperCase(Config.Strings[dummyb]))>0 THEN
      // exclude filters
      BEGIN
        IF Config.Count-1>dummyb THEN
        // if value is missing ignore
        BEGIN
          Inc(dummyb);
          IF ExcFilter=nil THEN ExcFilter:=TStringList.Create;
          ExcFilter.Add(UpperCase(Config.Strings[dummyb]));
        END
      END
      ELSE IF (Pos('/BM',UpperCase(Config.Strings[dummyb]))>0)
           OR (Pos('/BUTTON',UpperCase(Config.Strings[dummyb]))>0) THEN
      // custom button
      BEGIN
        IF Config.Count-1>dummyb+1 THEN
        // if values are missing ignore
        BEGIN
//          CustomButton.Visible:=TRUE;
          Inc(dummyb);
          dummys:=Config.Strings[dummyb];
          Inc(dummyb);
          AddBookMark(dummys,Config.Strings[dummyb]);
        END
        // in case only one value of the custom button parameter is present, ignore silently
        ELSE IF Config.Count-1>dummyb THEN Inc(dummyb);
      END
      ELSE
      BEGIN
        IF HomeURL='about:blank' THEN HomeURL:=Config.Strings[dummyb];
//        CreateMDIChild(Config.Strings[dummyb]);
        AutoURL.Add(Config.Strings[dummyb]);
      END;
      Inc(dummyb);
    END;//WHILE dummyb<=ParamCount
    Config.Free;
  END; // If ParamCount > 0
// If no in- and exclusions are given, allow everything
  IF (ExcFilter<>nil) AND (IncFilter=nil) THEN
  BEGIN
    IncFilter:=TStringList.Create;
    Incfilter.Add('/');
  END;
  IF IncFilter<>nil THEN IncFilter.Add('ABOUT: ');
  // This is to allow error messages in a nice way.

end; //  FormCreate

procedure TMainForm.CreateMDIChild(const URL: string);
begin
  { create a new MDI child window }
  WITH TMDIChild.Create(Application) DO
  BEGIN
    Caption:='New Internet Browser';
//    Name:='MDI'+IntToStr(MainForm.MDIChildCount);
    IF URL <> '' THEN WebBrowser.Navigate(URL);
  END;
end;

procedure TMainForm.FileNew1Execute(Sender: TObject);
begin
  CreateMDIChild('');
end;

procedure TMainForm.HelpAbout1Execute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;


procedure TMainForm.FormDestroy(Sender: TObject);
VAR b:Byte;
begin
  Icons[0].Destroy;
  Icons[1].Destroy;
  IF GoToMenu.Count > 0 THEN
    FOR b:=GoToMenu.Count-1 DOWNTO 0 DO
    BEGIN
      GoToMenu.Items[b].Free;
    END;
  Bookmarks.Free;
  AutoURL.Free;
  IncFilter.Free;
  ExcFilter.Free;
// Release the Filter
(* With Filter DO
 BEGIN
    Proto.Inc.Free;
    Proto.Exc.Free;
    Host.Inc.Free;
    Host.Exc.Free;
    Path.Inc.Free;
    Path.Exc.Free;
  END
*)
end;

procedure TMainForm.GoToMenuClick(Sender: TObject);
begin
  CreateMDIChild(BookMarks.Strings[(Sender as TMenuItem).Tag]);
end;


procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  IF NoExit THEN WinExec(CmdLine,0);
end;

procedure TMainForm.FormShow(Sender: TObject);
VAR dummyb:Word;
begin
//  Sleep(2000);
  IF AutoDebug THEN
  BEGIN
    DebugForm.Show;
    Debug('Command Line Options: '+string(cmdline));
    Debug('Configuration: '+OpenNewWindowParams);
    Debug('HomeURL: '+HomeURL);
    Debug('AutoURL: '+CRLF+AutoURL.Text);
    Debug('BookMarks: '+CRLF+Bookmarks.Text);
    IF IncFilter<>nil THEN Debug('IncFilter: '+CRLF+IncFilter.Text);
    IF ExcFilter<>nil THEN Debug('ExcFilter: '+CRLF+ExcFilter.Text);
  END;
  IF (AutoURL.Count > 0) THEN
      FOR dummyb:=AutoURL.Count-1 DOWNTO 0 DO
        CreateMDIChild(AutoURL[dummyb]);
  TileTimer.Enabled:=TRUE;
end;

procedure TMainForm.IPC(VAR Msg:TMessage);
begin
IF Msg.WParam = 1 THEN FormShow(MainForm);
end;

procedure TMainForm.CloseTimerTimer(Sender: TObject);
begin
  IF FirstTime THEN FirstTime:=FALSE
  ELSE MainForm.Close;
end;

procedure TMainForm.TileTimerTimer(Sender: TObject);
begin
  IF FirstTime THEN FirstTime:=FALSE
  ELSE
  BEGIN
    FirstTime:=TRUE;
    TileTimer.Enabled:=FALSE;
    TileMode:=tbHorizontal;
    Tile;
  END;
end;

procedure TMainForm.FilePrint1Execute(Sender: TObject);
begin
// do nothing if there is no active MDI child
     IF ActiveMDIChild<>NIL THEN
     WITH TMDIChild(MainForm.ActiveMDIChild) DO
     try
       IF WebBrowser.QueryStatusWB(OLECMDID_PRINT) AND OLECMDF_ENABLED = OLECMDF_ENABLED THEN
       BEGIN
         IF DebugForm.Visible THEN Debug('Printing window "'+WebBrowser.LocationURL+'"');
         WebBrowser.ExecWB(OLECMDID_PRINT,OLECMDEXECOPT_DONTPROMPTUSER);
       END
       ELSE
         IF DebugForm.Visible THEN Debug('Printing window "'+WebBrowser.LocationURL+'" failed because OLECMD not enabled !');
     except
     ON E:Exception DO IF DebugForm.Visible THEN
       Debug('Printing window "'+WebBrowser.LocationURL+'" raised exception '+E.Message+' !');
// Silently ignore all exceptions
     end;
end;

begin
  AboutString:='about:<head><meta http-equiv="Content-Type"content="text/html; charset=iso-8859-1"><meta name="GENERATOR" content="Microsoft FrontPage Express 2.0"><title>About ResBrow</title>'+
              '</head><body bgcolor="#FFFFFF"><h1 align="center">ResBrow</h1><h2 align="center">Restricted Browser</h2><h3 align="center">Version '+version+'</h3><h4 align="center">FreeWare</h4>'+
              '<hr width="50%"><p align="center">'+DateToStr(Now)+'<br>Schlomo Schapiro<br>Hebrew University of Jerusalem<br><a href="http://shum.cc.huji.ac.il/~schapiro">http://shum.cc.huji.ac.il/~schapiro</a>'+
              '<br><a href="mailto://schapiro@huji.ac.il">schapiro@huji.ac.il</a></p></body>';

  FirstTime:=TRUE;



end.
