unit MainUnit;
{
New in v 1.1:

Add support to spawn a new browser when a new window is requested or the window
is closed.

Add support for close browser token in url

Add config read from file

New in v 1.2:

Add config read from URL

New in v 1.2.1:
Done 25.5.2000

Fixed /Forcemax bug that didn't disable the window border

}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, OleCtrls, Menus, ComCtrls, SHDocVw,
  Buttons, Psock, NMHttp;

CONST
  BackupConfig = '/NOCLOSE'+#$A+
                 '/I'+#$A+
                 'about:'+#$A+
                 '/FET'+#$A+
                 'Could not read Configuration. Please call the Administrator !'+#$A+
                 '/STAYTOP'+#$A+
                 '/NOURL'+#$A+
                 '/FORCEMAX'+#$A+
                 'about: Could not read Configuration. Please call the Administrator !';

  ResBrowHTTPToken='RESBROW';


type
  TMain = class(TForm)
    TopPanel: TPanel;
    URLLabel: TLabel;
    URLEdit: TEdit;
    ExitButton: TButton;
    HTMLPopUp: TPopupMenu;
    Back1: TMenuItem;
    Next1: TMenuItem;
    StatusBarTimer: TTimer;
    WebBrowser: TWebBrowser;
    BottomPanel: TPanel;
    ProgressBar: TProgressBar;
    StatusBar: TStatusBar;
    CustomButton: TButton;
    BackButton: TSpeedButton;
    ForwardButton: TSpeedButton;
    HomeButton: TSpeedButton;
    StopButton: TSpeedButton;
    sdfg: TMenuItem;
    erwt: TMenuItem;
    CloseTimer: TTimer;
    procedure ExitButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure HTMLBeginRetrieval(Sender: TObject);
    procedure HTMLEndRetrieval(Sender: TObject);
    procedure URLEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CheckURL(Sender: TObject; const pDisp: IDispatch; var URL,
      Flags, TargetFrameName, PostData, Headers: OleVariant;
      var Cancel: WordBool);
    procedure ChangeStatusText(Sender: TObject; const Text: WideString);
    procedure BackButtonClick(Sender: TObject);
    procedure CheckNewWindow(Sender: TObject; var ppDisp: IDispatch;
      var Cancel: WordBool);
    procedure SetProgressBar(Sender: TObject; Progress,
      ProgressMax: Integer);
    procedure ChangeTitle(Sender: TObject; const Text: WideString);
    procedure CheckResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ClockUpdate(Sender: TObject);
    procedure HomeButtonClick(Sender: TObject);
    procedure CustomButtonClick(Sender: TObject);
    procedure ForwardButtonClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure WebBrowserCommandStateChange(Sender: TObject;
      Command: Integer; Enable: WordBool);
    procedure WebBrowserQuit(Sender: TObject);
    procedure CloseTimerTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    NoExit:Boolean;
    procedure StatusBarTimerCloseMain(Sender:TObject);
  end;

var
  Main: TMain;
  OpenNewWindowParams:String='';
  CloseOnURL:String='';

CONST
  AboutString='about:<head><meta http-equiv="Content-Type"content="text/html; charset=iso-8859-1"><meta name="GENERATOR" content="Microsoft FrontPage Express 2.0"><title>About ResBrow</title>'+
              '</head><body bgcolor="#FFFFFF"><h1 align="center">ResBrow</h1><h2 align="center">Restricted Browser</h2><h3 align="center">Version 1.21</h3><h4 align="center">FreeWare</h4>'+
              '<hr width="50%"><p align="center">25.5.2000<br>Schlomo Schapiro<br>Hebrew University of Jerusalem<br><a href="http://shum.cc.huji.ac.il/~schapiro">http://shum.cc.huji.ac.il/~schapiro</a>'+
              '<br><a href="mailto://schapiro@cc.huji.ac.il">schapiro@pob.huji.ac.il</a></p></body>';

implementation


VAR ForceMaxFirstResize:Boolean = FALSE ;
    IncFilter,ExcFilter:TStringList;
    HomeURL:String = 'about:blank';
    CustomURL:String = '';
    Icons:Array [0..1] of TBitMap;
    FirstTime:Boolean=TRUE;

    FilterErrorText:String = 'Access to the requested site has been restricted !';

{$R *.DFM}

{$R data.res}

procedure TMain.ExitButtonClick(Sender: TObject);
begin
Main.Close;
end;

procedure TMain.FormCreate(Sender: TObject);
VAR Flags,TargetFrameName,PostData,Headers:OLEVariant;
    dummyb:Word;
    dummyi:Integer;
    config:TStringList;
    HTTP:TNMHTTP;
    TempPath:Array [0..255] of Char;
begin
  NoExit:=FALSE;
  IF ParamCount>0 THEN
  BEGIN
    Config:=TStringList.Create;
    FOR dummyb:=1 TO ParamCount DO //collect params for next instance of ResBrow (for the /noclose option)
      OpenNewWindowParams := OpenNewWindowParams +' "'+ParamStr(dummyb)+'"';
    IF (ParamStr(1)='/@') AND ((ParamCount=2) OR (ParamCount=3)) THEN
    BEGIN
      // Read params from file or command line
      IF Pos('HTTP:',UpperCase(ParamStr(2)))>0 THEN
      BEGIN
      // Read from URL
         HTTP:=TNMHTTP.Create(Application);
         HTTP.TimeOut:=10000;
         try
           try
             HTTP.Get(ParamStr(2));
             IF Pos(ResBrowHTTPToken,UpperCase(HTTP.Body))=0 THEN
             // not a valid ResBrow configuration, if save param given try previous config
             // otherwise go to safe mode and try again later
             BEGIN
               IF (ParamCount=3) AND (Pos('/SAVE',UpperCase(ParamStr(3)))>0) THEN
               BEGIN
                 try
                   IF GetTempPath(256,@TempPath)>0 THEN
                   // got temp dir
                   BEGIN
                     Config.LoadFromFile(String(temppath)+'RESBROW.CFG');
                     // got some file, check wether it's our config file
                     IF Pos(ResBrowHTTPToken,UpperCase(Config.Text))=0 THEN
                     // didn't find token, must be empty of fake. go back to safe mode and try again later
                     BEGIN
                       Config.Text:=BackupConfig;
                       CloseTimer.Enabled:=TRUE;
                     END
                     // if all is OK delete token
                     ELSE Config.Delete(Config.IndexOf(ResBrowHTTPToken));
                   END;
                 except
                 // if any problem happened during recovery from the previously saved config, go to save mode and try again
                   Config.Text:=BackupConfig;
                   CloseTimer.Enabled:=TRUE;
                 end;
               END // IF /SAVE is given
               ELSE
               // this happens if the downlaod fails and no /SAVE option was given
               BEGIN
                 Config.Text:=BackupConfig;
                 CloseTimer.Enabled:=TRUE;
               END;
             END
             ELSE
             // means we downloaded a valid config from the internet.
             BEGIN
               Config.Text:=HTTP.Body;
               IF (ParamCount=3) AND (Pos('/SAVE',UpperCase(ParamStr(3)))>0) THEN
               BEGIN
               // this means we have to save the good config to the local file
                 try
                   IF GetTempPath(256,@TempPath)>0 THEN
                   // got temp dir
                   BEGIN
                     Config.SaveToFile(String(TempPath)+'RESBROW.CFG');
                   END;
                 except
                 end;
               END; // IF /SAVE was given
               // remove the token
               Config.Delete(Config.IndexOf(ResBrowHTTPToken));
             END; // we found a valid config
           except
           // if anything happens during the whole internet-related stuff, try to read old config (if /SAVE) or go safe mode
             IF (ParamCount=3) AND (Pos('/SAVE',UpperCase(ParamStr(3)))>0) THEN
             BEGIN
               try
                 IF GetTempPath(256,@TempPath)>0 THEN
                 // got temp dir
                 BEGIN
                   Config.LoadFromFile(String(temppath)+'RESBROW.CFG');
                   // got some file, check wether it's our config file
                   IF Pos(ResBrowHTTPToken,UpperCase(Config.Text))=0 THEN
                   // didn't find token, must be empty of fake. go back to safe mode and try again later
                   BEGIN
                     Config.Text:=BackupConfig;
                     CloseTimer.Enabled:=TRUE;
                   END
                   // if all is OK delete token
                   ELSE Config.Delete(Config.IndexOf(ResBrowHTTPToken));
                 END;
               except
               // if any problem happened during recovery from the previously saved config, go to save mode and try again
                 Config.Text:=BackupConfig;
                 CloseTimer.Enabled:=TRUE;
               end;
             END // IF /SAVE is given
             ELSE
             // this happens if the downlaod fails and no /SAVE option was given
             BEGIN
               Config.Text:=BackupConfig;
               CloseTimer.Enabled:=TRUE;
             END;
           END;
         finally
           HTTP.Free;
         end;
      END
      ELSE
        try
          Config.LoadFromFile(ParamStr(2))
        except
        // if we couldn't read from the file, go safe mode.
           Config.Text:=BackupConfig;
           CloseTimer.Enabled:=TRUE;
        END;
    END // /@ found. Now begins the "classical" command line parameters evaluation
    ELSE FOR dummyb:=1 TO ParamCount DO Config.Add(ParamStr(dummyb));
    dummyb:=0;
    // eat params one by one
    WHILE dummyb<Config.Count DO
    BEGIN
      IF Pos('/?',Config.Strings[dummyb])>0 THEN
      BEGIN
        Application.MessageBox(pchar('Restricted Browser v 1.2'+#$D#$A+
                                     ''+#$D#$A+
                                     'A highly restrictable IE browser for public access computers'+#$D#$A+
                                     'Needs IE 4 or higher installed to function'+#$D#$A+
                                     ''+#$D#$A+
                                     'Usage: ResBrow [Options] [URL]'+#$D#$A+
                                     'Options:'+#$D#$A+
                                     '/HOME <URL>'+#9#9+'Sets the home address'+#$D#$A+
                                     '/NOURL'+#9#9+'Disables the Address bar'+#$D#$A+
                                     '/MAX'+#9#9+'Opens the program maximized'+#$D#$A+
                                     '/CLOSEON <Token>'+#9+'Close Browser if the token is found in URL'+#$D#$A+
                                     '/FORCEMAX'+#9+'As /MAX but doesn''t allow resizing'+#$D#$A+
                                     '/NOCLOSE'+#9+'Prevents the program from beeing closed, disables'+#$D#$A+
                                     #9#9+'Ctrl-Alt-Del and the Task Manager on Win9x'+#$D#$A+
                                     '/STAYTOP'+#9+'Forces the window to stay the topmost'+#$D#$A+
                                     '/BUTTON <Label|Hint> <URL>'+#9+'Adds custom button that links to URL'+#$D#$A+
                                     '/FET <Text>'+#9+'Changes the Filter Error Text'+#$D#$A+
                                     '/I <Token>'+#9+'Shows only URLs containing Token'+#$D#$A+
                                     #9#9+'Use several /I to allow access to several sites'+#$D#$A+
                                     '/X <Token>'+#9+'Restricts access to URLs containing Token'+#$D#$A+
                                     #9#9+'Use several /X to combine limitations'+#$D#$A+
                                     ''+#$D#$A+
                                     'The URL supplied on the command line is taken as'+#$D#$A+
                                     'initial URL. It has to be supplied after all options.'+#$D#$A+
                                     'Use /NOURL /FORCEMAX /NOCLOSE /STAYTOP for maximium '+#$D#$A+
                                     'kiosk mode. Disable Ctrl-Alt-Del and the Task Manager (on NT).'+#$D#$A+
                                     ''+#$D#$A+
                                     'The /NOCLOSE options does not really prevent the browser from beeing'+#$D#$A+
                                     'closed, but starts a new browser with the same parameters if the current'+#$D#$A+
                                     'browser gets closed'+#$D#$A+
                                     'Written 16.12.1999 by Schlomo Schapiro'),'About',MB_OK);
        Application.Terminate;
      END
      ELSE IF Pos('/HOME',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
        // if no parameter supplied ignore silently.
        IF Config.Count-1>dummyb THEN
        BEGIN
          Inc(dummyb);
          HomeURL:=Config.Strings[dummyb];
        END;
      END
      ELSE IF Pos('/CLOSEON',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
        // if no parameter supplied ignore silently.
        IF Config.Count-1>dummyb THEN
        BEGIN
          Inc(dummyb);
          CloseOnURL:=UpperCase(Config.Strings[dummyb]);
        END;
      END
      ELSE IF Pos('/NOURL',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
        URLEdit.ReadOnly:=TRUE;
        URLEdit.Color:=clInactiveCaptionText;
      END
      ELSE IF Pos('/NOCLOSE',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
        Main.BorderIcons:= [] ;
        ExitButton.Enabled:=FALSE;
        Main.Update;
        NoExit:=TRUE;
        SystemParametersInfo (97, Word (True), @Dummyi, 0); {no alt-tab or ctrl-alt-del any more}
      END
      ELSE IF Pos('/MAX',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
        Main.WindowState := wsMaximized
      END
      ELSE IF Pos('/FORCEMAX',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
        Main.WindowState := wsMaximized;
//        ExitButton.Left:=Screen.Width-(ExitButton.Width+20);
//        UrlEdit.Width:=Screen.Width-URLEdit.Left-ExitButton.Width-40;
        StatusBar.Panels[0].Width:=Screen.Width-50;
        StatusBar.Panels[1].Width:=50;
        Main.BorderStyle:=bsNone;
//        Application.MessageBox(pchar('screen.width='+IntToStr(screen.width)+'exitbutton.left='+inttostr(exitbutton.left)+' urledit.right='+inttostr(urledit.width+urledit.left)),pchar('info'),MB_OK);
        // I assume that ResBrowser runs as a kiosk application. otherwise it doesn't make sense
      END
      ELSE IF Pos('/STAYTOP',UpperCase(Config.Strings[dummyb]))>0 THEN
      BEGIN
        Main.FormStyle:=fsStayOnTop;
      END
      ELSE IF Pos('/FET',UpperCase(Config.Strings[dummyb]))>0 THEN
      // Filter Error Text
      BEGIN
        IF Config.Count-1>dummyb THEN
        // if value is missing ignore
        BEGIN
          Inc(dummyb);
          FilterErrorText:=Config.Strings[dummyb];
        END;
      END
      ELSE IF Pos('/I',UpperCase(Config.Strings[dummyb]))>0 THEN
      // include filters
      BEGIN
        IF Config.Count-1>dummyb THEN
        // if value is missing ignore
        BEGIN
          Inc(dummyb);
          IF IncFilter=nil THEN IncFilter:=TStringList.Create;
          IncFilter.Add(UpperCase(Config.Strings[dummyb]));
        END
      END
      ELSE IF Pos('/X',UpperCase(Config.Strings[dummyb]))>0 THEN
      // exclude filters
      BEGIN
        IF Config.Count-1>dummyb THEN
        // if value is missing ignore
        BEGIN
          Inc(dummyb);
          IF ExcFilter=nil THEN ExcFilter:=TStringList.Create;
          ExcFilter.Add(UpperCase(Config.Strings[dummyb]));
        END
      END
      ELSE IF Pos('/BUTTON',UpperCase(Config.Strings[dummyb]))>0 THEN
      // exclude filters
      BEGIN
        IF Config.Count-1>dummyb+1 THEN
        // if values are missing ignore
        BEGIN
          CustomButton.Visible:=TRUE;
          Inc(dummyb);
          IF Pos('|',Config.Strings[dummyb])>0 THEN
          // set up hint, too
          BEGIN
            CustomButton.Hint:=Copy(Config.Strings[dummyb],Pos('|',Config.Strings[dummyb])+1,Length(Config.Strings[dummyb])-Pos('|',Config.Strings[dummyb]));
            CustomButton.ShowHint:=TRUE;
            CustomButton.Caption:=Copy(Config.Strings[dummyb],1,Pos('|',Config.Strings[dummyb])-1);
          END
          ELSE CustomButton.Caption:=Config.Strings[dummyb];
          Inc(dummyb);
          CustomURL:=Config.Strings[dummyb];
        END
        // in case only one value of the custom button parameter is present, ignore silently
        ELSE IF Config.Count-1>dummyb THEN Inc(dummyb);
      END
      ELSE
      BEGIN
        IF HomeURL='about:blank' THEN HomeURL:=Config.Strings[dummyb];
        WebBrowser.Navigate(Config.Strings[dummyb],Flags,TargetFrameName,PostData,Headers);
      END;
      Inc(dummyb);
    END;//WHILE dummyb<=ParamCount
    Config.Free;
  END; // If ParamCount > 0
//  OpenNewWindowURL:=HomeURL;
  HomeButton.Hint:='Home ('+HomeURL+')';
  //URLEdit.Constraints.MaxWidth:=Main.Width - URLLabel.Width - ExitButton.Width - BackButton.Width;
  IF (ExcFilter<>nil) AND (IncFilter=nil) THEN
  BEGIN
    IncFilter:=TStringList.Create;
    Incfilter.Add('/');
  END;
  IF IncFilter<>nil THEN IncFilter.Add('ABOUT: ');
  // This is to allow error messages in a nice way.
  Main.ClockUpdate(Sender);
  Icons[0]:=TBitMap.Create;
  Icons[1]:=TBitMap.Create;
  Icons[0].Handle:=LoadBitmap(HINSTANCE,'stop');
  Icons[1].Handle:=LoadBitmap(HINSTANCE,'refresh');
  HTMLEndRetrieval(Sender);
end;

procedure TMain.HTMLBeginRetrieval(Sender: TObject);
begin
StopButton.Glyph:=Icons[0];
StopButton.Hint:='Stop';
end;

procedure TMain.HTMLEndRetrieval(Sender: TObject);
begin
StatusBar.Panels[0].Text:=WebBrowser.LocationName;
URLEdit.Text:=WebBrowser.LocationURL;
ProgressBar.Position:=0;
StopButton.Glyph:=Icons[1];
StopButton.Hint:='Refresh';
end;

procedure TMain.URLEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
VAR Flags,TargetFrameName,PostData,Headers:OLEVariant;
begin
  IF Key=13 THEN
  try
    WebBrowser.Navigate(URLEdit.Text,Flags,TargetFrameName,PostData,Headers);
  except
    Main.Close;
  END;
end;


procedure TMain.CheckURL(Sender: TObject; const pDisp: IDispatch; var URL,
  Flags, TargetFrameName, PostData, Headers: OleVariant;
  var Cancel: WordBool);
VAR dummyb:Byte;
    URL_:String;
begin
  //Application.MessageBox('CheckURL','Info',MB_OK);
  Cancel:=TRUE;
  URL_:=UpperCase(URL);
  IF Pos(CloseOnURL,URL_)>0 THEN
  BEGIN
    StatusBarTimer.Interval:=1000;
    StatusBarTimer.OnTimer:=StatusBarTimerCloseMain;
    Exit;
  END;
  dummyb:=0;
  IF IncFilter<>nil THEN
    WHILE (dummyb<IncFilter.Count) AND Cancel DO
    BEGIN
      Cancel:=NOT (Pos(IncFilter[dummyb],URL_)>0);
      Inc(dummyb);
    END;
  dummyb:=0;
  IF NOT Cancel AND (ExcFilter<>nil) THEN
    WHILE (dummyb<ExcFilter.Count) AND NOT Cancel DO
    BEGIN
      Cancel:=(Pos(ExcFilter[dummyb],URL_)>0);
      Inc(dummyb);
    END;
  IF IncFilter=nil THEN Cancel:=FALSE;
  IF (URL='about:NavigationCanceled') OR (Pos('RES:',URL_)>0) THEN Cancel:=TRUE
  ELSE IF Cancel THEN
  BEGIN
    Beep;
    Application.MessageBox(pchar(FilterErrorText),pchar(string(URL)),MB_ICONSTOP);
  //  WebBrowser.Navigate(URL,Flags,TargetFrameName,PostData,Headers);
  END
  ELSE
  // site is OK, let's browse there
  BEGIN
    // about:version check
    IF (Pos('VERSION',URL_)>0) AND (pos('VERSION',URL_)<12) THEN
    BEGIN
      WebBrowser.Navigate(AboutString);
      Cancel:=TRUE;
    END;
    Flags:=14;
    // 14 is max restriction: no cache, no history etc. look at msdn.microsoft.com for info
  END;
end;

procedure TMain.ChangeStatusText(Sender: TObject; const Text: WideString);
begin
StatusBar.Panels[0].Text:=Text;
end;

procedure TMain.BackButtonClick(Sender: TObject);
begin
try
  WebBrowser.GoBack;
except
end;
end;

procedure TMain.CheckNewWindow(Sender: TObject; var ppDisp: IDispatch;
  var Cancel: WordBool);
begin
//  Application.MessageBox('CheckNewWindow','Info',MB_OK);
//  OpenNewWindow:=TRUE;
//  Main.Close;
  Cancel:=TRUE;
  StatusBar.Panels.Items[0].Text:='Opening new windows is not allowed !';
end;

procedure TMain.SetProgressBar(Sender: TObject; Progress,
  ProgressMax: Integer);
begin
  IF (Progress>-1) AND (ProgressMax>0) THEN ProgressBar.Position:=Round(Progress*100/ProgressMax)
  ELSE IF Progress=0 THEN ProgressBar.Position:=0;
end;

procedure TMain.ChangeTitle(Sender: TObject; const Text: WideString);
begin
Main.Caption:=Text;
Application.Title:=Text;
end;

procedure TMain.CheckResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
//Resize:=NOT ForceMaxFirstResize;
end;

procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // if we have to open a new window, open it and then close this one.
  IF NoExit THEN
  BEGIN
//    Application.MEssageBox(pchar(ParamStr(0)+' '+OpenNewWindowParams),'Info',MB_OK);
    WinExec(pchar(ParamStr(0)+' '+OpenNewWindowParams),SW_SHOWDEFAULT );
  END;
  // cleanup & exit
  IF IncFilter<>nil THEN IncFilter.Free;
  IF ExcFilter<>nil THEN ExcFilter.Free;
  Icons[0].Destroy;
  Icons[1].Destroy;
END;

procedure TMain.FormShow(Sender: TObject);
begin
//ForceMaxFirstResize:=(Main.BorderStyle = bsNone);
end;


procedure TMain.FormResize(Sender: TObject);
begin
  IF NOT (Main.BorderStyle = bsNone) THEN
  BEGIN
    StatusBar.Panels[0].Width:=Self.Width-55;
    StatusBar.Panels[1].Width:=50;
  END;
end;

procedure TMain.ClockUpdate(Sender: TObject);
begin
IF WebBrowser=nil THEN Main.Close;
StatusBar.Panels[1].Text:=FormatDateTime('hh:nn',Now);
end;

procedure TMain.StatusBarTimerCloseMain(Sender:TObject);
begin
// Disable Timer and close window.
  StatusBarTimer.Interval:=0;
  Main.Close;
end;

procedure TMain.HomeButtonClick(Sender: TObject);
VAR Flags,TargetFrameName,PostData,Headers:OLEVariant;
begin
  try
    WebBrowser.Navigate(HomeURL,Flags,TargetFrameName,PostData,Headers);
  except
    Main.Close;
  end;
//  WebBrowser.ExecWB(40002,0,Flags,Headers);
// 40002 = IDM_FONT
end;

procedure TMain.CustomButtonClick(Sender: TObject);
VAR Flags,TargetFrameName,PostData,Headers:OLEVariant;
begin
  try
    WebBrowser.Navigate(CustomURL,Flags,TargetFrameName,PostData,Headers);
  except
    Main.Close;
  end;
end;

procedure TMain.ForwardButtonClick(Sender: TObject);
begin
  try
    WebBrowser.GoForward;
  except
  end;
end;

procedure TMain.StopButtonClick(Sender: TObject);
begin
  try
    IF StopButton.Hint='Stop' THEN WebBrowser.Stop ELSE WebBrowser.Refresh;
  finally
  end;
end;

procedure TMain.WebBrowserCommandStateChange(Sender: TObject;
  Command: Integer; Enable: WordBool);
{
This enables/disables the back/forward buttons. See WebBrowser doc for info
}
begin
  CASE Command OF
    1: ForwardButton.Enabled:=Enable;
    2: BackButton.Enabled:=Enable;
  END;
end;

procedure TMain.WebBrowserQuit(Sender: TObject);
begin
  Main.Close;
end;

procedure TMain.CloseTimerTimer(Sender: TObject);
begin
  IF FirstTime THEN FirstTime:=FALSE
  ELSE Main.Close;
end;

end.







